package blocking_queue.pizzeria;

import java.util.HashSet;
import java.util.concurrent.ArrayBlockingQueue;
import java.util.concurrent.BlockingQueue;

class BlockingSet<E> extends HashSet<E> {
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	
	final int tagliaMassima = 10;

	@Override
	public synchronized boolean add(final E e) {
		while (size() == tagliaMassima)
			try {
				this.wait();
			} catch (final InterruptedException e1) {
				// TODO Auto-generated catch block
				e1.printStackTrace();
			}
		notifyAll();
		return super.add(e);
	}

	@Override
	public synchronized boolean remove(final Object o) {
		boolean retValue;
		while (!(retValue = super.remove(o)))
			try {
				wait();
			} catch (final InterruptedException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		notifyAll();
		return retValue;
	}
};

class Ordine {
	static int nextCodiceOrdine = 0;
	TipoPizza tipoPizza;
	int quantita;
	int codiceOrdine;
	String pizze = "";

	Ordine(final TipoPizza t, final int q) {
		tipoPizza = t;
		quantita = q;
		codiceOrdine = Ordine.nextCodiceOrdine++;
	}

	void prepara() {
		for (int i = 0; i < quantita; i++)
			pizze += "(*)";
	}
}

class Pizzeria {
	BlockingQueue<Ordine> bo = new ArrayBlockingQueue<>(10);
	HashSet<Ordine> bp = new BlockingSet<>();

	Ordine getOrdine() {
		try {
			return bo.take();
		} catch (final InterruptedException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return null;
	}

	void getPizze(final Ordine ordine) {
		bp.remove(ordine);
	}

	Ordine putOrdine(final TipoPizza codicePizza, final int quantita) {
		final Ordine ordine = new Ordine(codicePizza, quantita);
		try {
			bo.put(ordine);
		} catch (final InterruptedException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return ordine;
	}

	void putPizze(final Ordine ordine) {
		bp.add(ordine);
	}

}

public class PizzeriaFattaALezione {
	final public static void main(final String args[]) {

		final Pizzaiolo[] p = new Pizzaiolo[3];
		final Cliente[] c = new Cliente[10];
		final Pizzeria daToto = new Pizzeria();
		int i;
		for (i = 0; i < 3; i++) {
			p[i] = new Pizzaiolo("Totonno_" + Integer.toString(i), daToto);
			p[i].start();
		}
		for (i = 0; i < 10; i++) {
			c[i] = new Cliente("Geppino_" + Integer.toString(i), daToto);
			c[i].start();
		}

	}
}

enum TipoPizza {
	margherita, quattrostagioni, capricciosa
}
